"use strict";
Object.defineProperty(exports, "__esModule", { value: true });

const core = require('./core/core');
const engine = require('./core/engine-javascript');

exports.createHighlighterCore = core.createHighlighterCore;
exports.createJavaScriptRegexEngine = engine.createJavaScriptRegexEngine;

// Load and export all languages and themes
exports.languages = {};
exports.themes = {};

// Export commonly used languages and themes by default
exports.typescript = require('./langs/typescript').default;
exports.javascript = require('./langs/javascript').default;
exports.json = require('./langs/json').default;
exports.githubDark = require('./themes/github-dark').default;
exports.githubLight = require('./themes/github-light').default;